# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages

stages:          # List of stages for jobs, and their order of execution
  - docker

docker-build:
  # Use the official docker image.
  image: docker:latest
  stage: docker
  services:
    - docker:dind
  variables:
    IMAGE_NAME: "php:7.4-apache"
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  # Default branch leaves tag empty (= latest tag)
  # All other branches are tagged with the escaped branch name (commit ref slug)
  after_script:
    - docker logout
  script:
    - docker build -t $CI_REGISTRY/ashad.khan.dev/symfony-ci-cd/$IMAGE_NAME .
    - docker push $CI_REGISTRY/ashad.khan.dev/symfony-ci-cd/$IMAGE_NAME

    #- |
    #  if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
    #    tag=""
    #    echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
    #  else
    #    tag=":$CI_COMMIT_REF_SLUG"
    #    echo "Running on branch '$CI_COMMIT_BRANCH': tag = $tag"
    #  fi
    #- docker build --pull -t "$CI_REGISTRY_IMAGE${tag}" .
    #- docker push "$CI_REGISTRY_IMAGE${tag}"
  # Run this job in a branch where a Dockerfile exists
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - Dockerfile
